# Code of Conduct

Youki follows the [CNCF Code of Conduct](https://github.com/cncf/foundation/blob/main/code-of-conduct.md).

# Maintainership

Youki is governed by Maintainers who are elected from active contributors.
Youki will remain [vendor-neutral](https://contribute.cncf.io/maintainers/community/vendor-neutrality/).
Maintainers are [here](./maintainer.md).

## Roles

Maintainers consist of the following roles:

- Committer (Full maintainership)  
    Committers have full write accesses to repos.
    Committers’ commits should still be made via GitHub pull requests (except for urgent security fixes), and should not be pushed directly to the default branch.

- Reviewer (Limited maintainership)  
    Reviewers may moderate GitHub issues and pull requests (such as adding labels and cleaning up spams), but they do not have any access to merge pull requests nor push commits.
    A Reviewer is considered as a candidate to become a Committer.

## Addition and promotion of Maintainers

A contributor who have made significant contributions in quality and in quantity can be directly invited as a Committer.
A proposal to add or promote a Maintainer must be approved by 2/3 of the Committers who vote within 7 days.
Voting needs a minimum of 2 approvals. The proposer can vote too. Votes from the same company will be counted as one vote.
A proposal should be made via a GitHub pull request to the file containing the list of Maintainer defined above.
Before submitting the pull request, the proposer should reach out to the Committers to check their willingness to support the proposal.

## Removal and demotion of Maintainers

A Maintainer who do not show significant activities for 12 months, or, who violated the Code of Conduct, may be demoted or removed from the project.

A proposal to demote or remove a Maintainer must be approved by 2/3 of the Committers (excluding the person in question) who vote within 14 days.
Voting needs a minimum of 2 approvals. The proposer can vote too. Votes from the same company will be counted as one vote.

A proposal should be made via a GitHub pull request to the file containing the list of Maintainer defined above.
In the special case of removing a harmful Maintainer, this process can take place via a private discussion.
Before submitting the pull request, the proposer should reach out to the Committers to check their willingness.
